package com.ctg.ag.sdk.core.constant;

package ..deTemp.1736054890654;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

@Deprecated
public enum Method {
  GET("GET", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8"),
  POST_FORM("POST", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8"),
  POST_BODY_BINARY("POST", "application/octet-stream; charset=UTF-8", "application/json; charset=UTF-8"),
  POST_BODY_JSON("POST", "application/json; charset=UTF-8", "application/json; charset=UTF-8"),
  POST_BODY_XML("POST", "application/xml; charset=UTF-8", "application/json; charset=UTF-8"),
  POST_BODY_TEXT("POST", "application/text; charset=UTF-8", "application/json; charset=UTF-8"),
  PUT_FORM("PUT", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8"),
  PUT_BODY_BINARY("PUT", "application/octet-stream; charset=UTF-8", "application/json; charset=UTF-8"),
  PUT_BODY_JSON("PUT", "application/json; charset=UTF-8", "application/json; charset=UTF-8"),
  PUT_BODY_XML("PUT", "application/xml; charset=UTF-8", "application/json; charset=UTF-8"),
  PUT_BODY_TEXT("PUT", "application/text; charset=UTF-8", "application/json; charset=UTF-8"),
  PATCH_FORM("PATCH", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8"),
  PATCH_BODY_BINARY("PATCH", "application/octet-stream; charset=UTF-8", "application/json; charset=UTF-8"),
  PATCH_BODY_JSON("PATCH", "application/json; charset=UTF-8", "application/json; charset=UTF-8"),
  PATCH_BODY_XML("PATCH", "application/xml; charset=UTF-8", "application/json; charset=UTF-8"),
  PATCH_BODY_TEXT("PATCH", "application/text; charset=UTF-8", "application/json; charset=UTF-8"),
  DELETE("DELETE", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8"),
  HEAD("HEAD", "application/x-www-form-urlencoded; charset=UTF-8", "application/json; charset=UTF-8");
  
  private static final Map<String, com.ctg.ag.sdk.core.constant.Method> TYPES;
  
  private static final Map<String, com.ctg.ag.sdk.core.constant.Method> CONTENT_TYPES;
  
  private String name;
  
  private String requestContentType;
  
  private String acceptContentType;
  
  static {
    Map<String, com.ctg.ag.sdk.core.constant.Method> types = new HashMap<>(12);
    Map<String, com.ctg.ag.sdk.core.constant.Method> contentTypes = new HashMap<>(12);
    for (com.ctg.ag.sdk.core.constant.Method m : values()) {
      types.put(m.getName(), m);
      contentTypes.put(m.getRequestContentType(), m);
    } 
    TYPES = Collections.unmodifiableMap(types);
    CONTENT_TYPES = Collections.unmodifiableMap(contentTypes);
  }
  
  Method(String name, String requestContentType, String acceptContentType) {
    this.name = name;
    this.requestContentType = requestContentType;
    this.acceptContentType = acceptContentType;
  }
  
  public static com.ctg.ag.sdk.core.constant.Method of(String type) {
    return (type == null) ? null : TYPES.get(type.toUpperCase());
  }
  
  public static com.ctg.ag.sdk.core.constant.Method parseOf(String methodName, String requestContentType) {
    if (methodName == null || requestContentType == null)
      return null; 
    for (com.ctg.ag.sdk.core.constant.Method m : values()) {
      if (m.getName().equals(methodName) && m.getRequestContentType().equals(requestContentType))
        return m; 
    } 
    return null;
  }
  
  public String getName() {
    return this.name;
  }
  
  public String getRequestContentType() {
    return this.requestContentType;
  }
  
  public String getAcceptContentType() {
    return this.acceptContentType;
  }
  
  public static void main(String[] args) throws Exception {
    System.out.println(parseOf("PATCH", "application/json; charset=UTF-8"));
  }
}
